;===========================Eje2.ASM===================24-Oct.20=========
;Programa para tarjeta 5i-30r-1
;Enciende los tres Reles de salida con E0 y apaga los tres Reles con E1
;Cuando los reles encienden con un pequeo tiempo de retraso: RB7..RB6..RB5
;Al desenergizar tambien con un retrazo pero RB5..RB6..RB7
;Colocar Jumper J1 a J5 en 1
;-------------------------------------------------------------------------
porta		equ		0x05
portb           equ             0x06
count           equ     0x0c
ncount          equ     0x0d
mcount          equ     0x0e
;-------------------------------------------------------------------------
E0		equ		0x0
E1		equ		0x1
E2		equ		0x2
E3		equ		0x3
E4		equ		0x4
E5		equ		0x5
;-------------------------------------------------------------------------
	#DEFINE		EnciendeRB7	bsf	portb,7
	#DEFINE		EnciendeRB6 	bsf	portb,6
	#DEFINE		EnciendeRB5 	bsf	portb,5

	#DEFINE		ApagaRB7	bcf	portb,7
	#DEFINE		ApagaRB6	bcf	portb,6
	#DEFINE		ApagaRB5	bcf	portb,5
;-------------------------------------------------------------------------

Programa
               org             0x000


start           movlw           b'00000111'	;Define entradas salidas
                tris            portb
		movlw		b'00000001'
		tris		porta

		clrf		porta	  	;apaga puerto A
                clrf            portb      	;apaga puerto B           
                                        
		
ChecaBotones

ChecaE0Activado
		btfsc		portb,E0	;E0 esta activado ?	
		goto 		ChecaE0Activado	;No
		
                EnciendeRB7		   	;Enciende RB7
		call		pause
                EnciendeRB6
		call		pause
                EnciendeRB5
		call		pause

ChecaE0Desactivado
		btfss		portb,E0	;E0 esta desactivado ?
		goto		ChecaE0Desactivado


ChecaE1Activado
		btfsc		portb,E1	
		goto		ChecaE1Activado

		ApagaRB5
		call		pause
		ApagaRB6
		call		pause
		ApagaRB7
		call		pause
ChecaE1Desactivado
		btfss		portb,E1
		goto		ChecaE1Desactivado


		
		goto		ChecaBotones
;----------------------------------------------------------------------------
;Subrutinas
;----------------------------------------------------------------------------
pause           movlw   0xff            ;M
                movwf   mcount          ;to M counter
loadn           movlw   0xff            ;N
                movwf   ncount          ;to N counter
decn            decfsz  ncount,f        ;decrement N
                goto    decn            ;again
                decfsz  mcount,f        ;decrement M
                goto    loadn           ;again
                return                  ;done


;-------------------------------------------------------------------------
                end
;-------------------------------------------------------------------------


